package hu.kozadat.oaiaggregator;

import hu.kozadat.oaiaggregator.presentation.OAIPMHAwareJaxb2HttpMessageConverter;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.http.converter.HttpMessageConverter;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurationSupport;

import java.util.List;

/**
 * Created by tnagy on 2015.10.22..
 */
@Configuration
public class MVCConfigurator extends WebMvcConfigurationSupport {

    private static final Logger LOGGER = LoggerFactory.getLogger(MVCConfigurator.class);

    @Override
    protected void configureMessageConverters(List<HttpMessageConverter<?>> converters) {
        LOGGER.info("configureMessageConverters(): CALLED");
        converters.add(getOAIPMHHttpMessageConverter());
        addDefaultHttpMessageConverters(converters);
    }

    @Bean
    public OAIPMHAwareJaxb2HttpMessageConverter getOAIPMHHttpMessageConverter() {
        return new OAIPMHAwareJaxb2HttpMessageConverter();
    }

}
