package hu.kozadat.oaiaggregator;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.context.ConfigurableApplicationContext;
import org.springframework.context.annotation.Bean;
import org.springframework.oxm.jaxb.Jaxb2Marshaller;
import org.springframework.scheduling.annotation.EnableScheduling;

@SpringBootApplication
@EnableScheduling
public class OAIAggregatorApplication {

    private static final Logger LOGGER = LoggerFactory.getLogger(OAIAggregatorApplication.class);

    public static void main(String[] args) {
        ConfigurableApplicationContext context = SpringApplication.run(OAIAggregatorApplication.class, args);

        // listBeans(context);

    }

    private static void listBeans(ConfigurableApplicationContext context) {
        String[] beanDefinitionNames = context.getBeanDefinitionNames();
        for (String beanDefinitionName : beanDefinitionNames) {
            LOGGER.info("listBeans(): {} - > {}", beanDefinitionName, context.getBean(beanDefinitionName).getClass());
        }
    }

    @Bean
    public Jaxb2Marshaller unmarshaller() {
        Jaxb2Marshaller jaxb2Marshaller = new Jaxb2Marshaller();
        jaxb2Marshaller.setContextPaths(
                "org.purl.dc.elements._1",
                "hu.einfoszab.schema.kozadat.einfoszab_base",
                "hu.einfoszab.schema.kozadat.kozadat_adatbazis",
                "hu.einfoszab.schema.kozadat.kozadat_altalanos",
                "hu.einfoszab.schema.kozadat.kozadat_archiv",
                "hu.einfoszab.schema.kozadat.kozadat_jogszabalytervezet",
                "hu.einfoszab.schema.kozadat.kozadat_kozlony",
                "hu.einfoszab.schema.kozadat.kozadat_ogy_tvjavaslat"
        );
        return jaxb2Marshaller;
    }

}
