package hu.kozadat.oaiaggregator;

import hu.kozadat.oaiaggregator.service.OAIPMHService;
import hu.kozadat.oaiaggregator.service.oaipmh.Request;
import hu.kozadat.oaiaggregator.service.oaipmh.Response;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Created by tnagy on 2015.10.14..
 */
@RestController
public class OAIPMHController {

    @Autowired
    private OAIPMHService oaipmhService;

    @RequestMapping(value = "/oaiaggregator/oai", consumes = MediaType.ALL_VALUE, produces = MediaType.TEXT_XML_VALUE)
    public Response handle(
            HttpServletRequest httpServletRequest,
            HttpServletResponse httpServletResponse,
            @RequestParam(value = OAIPMHService.PARAMETER_VERB, required = false) String verb,
            @RequestParam(value = OAIPMHService.PARAMETER_METADATA_PREFIX, required = false) String metadataPrefix,
            @RequestParam(value = OAIPMHService.PARAMETER_RESUMPTION_TOKEN, required = false) String resumptionToken,
            @RequestParam(value = OAIPMHService.PARAMETER_IDENTIFIER, required = false) String identifier,
            @RequestParam(value = OAIPMHService.PARAMETER_FROM, required = false) String from,
            @RequestParam(value = OAIPMHService.PARAMETER_UNTIL, required = false) String until,
            @RequestParam(value = OAIPMHService.PARAMETER_SET, required = false) String set
    ) {

        String requestURL = httpServletRequest.getRequestURL().toString();

        Response response = oaipmhService.process(new Request(
                requestURL,
                verb,
                metadataPrefix,
                resumptionToken,
                identifier,
                from,
                until,
                set
        ));

        return response;

    }

}
