package hu.kozadat.oaiaggregator;

import hu.kozadat.oaiaggregator.service.oaipmh.ResumptionTokenManager;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.annotation.SchedulingConfigurer;
import org.springframework.scheduling.config.ScheduledTaskRegistrar;

/**
 * Created by tnagy on 2015.10.15..
 */
@Configuration
public class TaskConfigurator implements SchedulingConfigurer {

    @Autowired
    private ResumptionTokenManager tokenManager;

    @Value("${scheduler.expired_token_remover.period}")
    private long tokenRemoverPeriod;

    @Override
    public void configureTasks(ScheduledTaskRegistrar taskRegistrar) {
        taskRegistrar.addFixedRateTask(new Runnable() {
            @Override
            public void run() {
                tokenManager.removeExpired();
            }
        }, tokenRemoverPeriod);
    }

}
